CREATE PROCEDURE mergeepg ()
BEGIN
/*
* declare variables
*/
DECLARE startrun INT;
DECLARE lastrun INT;
/*
* configure merge
*/
set @epi ='a';
set @img ='b';
set @sht ='';
/*
* fix useid = 0
*/
update events set useid = masterid where useid = 0;
/*
* cleanup deleted Links
*/
update
 events e
set
 e.useid = e.masterid,
 e.updsp = unix_timestamp()
where
 e.source = 'vdr' and
 e.updflg in ('D','R') and
 e.useid != e.masterid and
 e.starttime + e.duration >= unix_timestamp();
/*
* cleanup broken Links
*/
update
 events t
 inner join
(
  select
   v.masterid,
   e.starttime,
   e.comptitle,
   e.compshorttext,
   e.updflg
  from
   events v
   left join
   events e
   on e.masterid = v.useid and v.masterid != e.masterid and e.updflg in ('T','C') and e.delflg is Null
  where
   v.updflg in('L') and
   v.starttime + v.duration >= unix_timestamp()
) s
on t.masterid=s.masterid
set
 t.useid = t.masterid,
 t.updflg = case when t.delflg = 'Y' then 'D' else 'A' end,
 t.updsp = unix_timestamp()
where
 s.updflg is Null or
 abs(s.starttime - t.starttime) > 21600  or
 (abs(s.starttime - t.starttime) > 3600 and
  getlvrmin(0,0,0,0,
   getcrosslvr(s.comptitle,t.comptitle),
   getcrosslvr(s.comptitle,t.compshorttext),
   getcrosslvr(s.compshorttext,t.comptitle),
   getcrosslvr(s.compshorttext,t.compshorttext)) >= 60);
/*
* cleanup broken Targets
*/
update
 events t
 inner join
(
  select
   e.masterid,
   v.updflg
  from
   events e
   left join
   events v
   on e.masterid = v.useid and v.masterid != e.masterid and v.updflg = 'L'
  where
   e.updflg in('C','T') and
   e.starttime + e.duration >= unix_timestamp()
) s
on t.masterid=s.masterid
set
 t.useid = t.masterid,
 t.updflg = case when t.delflg = 'Y' then 'D' else 'R' end,
 t.updsp = unix_timestamp()
where
 s.updflg is Null;
/*
* reset tables
*/
truncate snapshot;
truncate analyse;
/*
* prepare snapshot
*/
insert into snapshot
select
 distinct ev.channelid, ev.source, masterid, ev.eventid, useid, starttime, duration, title, comptitle, shorttext, compshorttext, ev.updsp,
  case when episodecompname is Null then Null else 'X' end episodecompname,
  case when ev.source = 'vdr' then Null else cm.merge end merge,
  case when ev.imagecount >0 then 'X' else Null end images
from
 events ev
 inner join channelmap cm on ( ev.channelid = cm.channelid )
where
 ( ev.source = cm.source or ev.source = 'vdr' )
 AND
 ev.updflg in ('I','A','R','S')
 AND
 ev.starttime between unix_timestamp() - ev.duration and unix_timestamp() + 259200
 AND
 cm.merge in(1,2);
/*
* do the magic
*/
set @pk1 ='';
set @rn1 =10000;
set @lvmin ='';
insert ignore into analyse
SELECT  channelid, vdr_masterid, vdr_eventid, vdr_starttime, vdr_duration, vdr_title, vdr_shorttext, ext_masterid, ext_eventid, ext_starttime, ext_duration, ext_title, ext_shorttext, ext_episodecompname, ext_merge, ext_images, lvmin,
          epi+img+sht + ranklv as rank
FROM
(
  SELECT  channelid, vdr_masterid, vdr_eventid, vdr_starttime, vdr_duration, vdr_title, vdr_shorttext, ext_masterid, ext_eventid, ext_starttime, ext_duration, ext_title, ext_shorttext, ext_episodecompname, ext_merge, ext_images, lvmin,
            case when ext_episodecompname is not Null then 0 else (case @epi when 'a' then 1000 when 'b' then 100 when 'c' then 10 else 0 end) end epi,
            case when ext_images is not Null then 0 else (case @img when 'a' then 1000 when 'b' then 100 when 'c' then 10 else 0 end) end img,
            case when ext_shorttext is not Null then 0 else (case @sht when 'a' then 1000 when 'b' then 100 when 'c' then 10 else 0 end) end sht,
          @rn1 := if(@pk1=concat(channelid,vdr_eventid,ext_source), if(@lv=lvmin, @rn1, @rn1+10000),10000+ext_merge) as ranklv,
          @pk1 := concat(channelid,vdr_eventid,ext_source),
          @lv := lvmin
  FROM
  (
    select
     vdr.channelid,
     vdr.masterid vdr_masterid, vdr.eventid vdr_eventid, vdr.starttime vdr_starttime, vdr.duration vdr_duration, vdr.title vdr_title, vdr.shorttext vdr_shorttext,
     ext.masterid ext_masterid, ext.eventid ext_eventid, ext.starttime ext_starttime, ext.duration ext_duration, ext.title ext_title, ext.shorttext ext_shorttext,
     ext.source ext_source,ext.episode ext_episodecompname, ext.merge ext_merge, ext.images ext_images,
     getlvrmin(vdr.starttime,ext.starttime,vdr.duration,ext.duration,
       getcrosslvr(vdr.comptitle,ext.comptitle),
       getcrosslvr(vdr.comptitle,ext.compshorttext),
       getcrosslvr(vdr.compshorttext,ext.comptitle),
       getcrosslvr(vdr.compshorttext,ext.compshorttext)
     ) lvmin
    from
     snapshot vdr
     inner join
     snapshot ext
     on vdr.channelid = ext.channelid and
     vdr.starttime - ext.starttime between -1200 and +1200 and
     vdr.duration / ext.duration * 100 between 50 and 200
    where
     vdr.source = 'vdr'
     AND
     vdr.source <> ext.source
    ORDER BY channelid,vdr_eventid,ext_merge desc,lvmin
  ) A
  where lvmin <= 60
) B
order by channelid,vdr_eventid,rank;
/*
* update mergesp
*/
update
 channelmap cm,
 (select channelid,max(vdr_starttime) merge_sp from analyse group by channelid) an
set
 cm.mergesp = an.merge_sp
where
 an.channelid = cm.channelid and
 an.merge_sp > cm.mergesp;
/*
* update useid on vdr events
*/
update
 events ev,
 analyse an
set
 ev.useid = an.ext_masterid
where
 ev.masterid = vdr_masterid and
 ev.channelid = an.channelid;
/*
* update useid on ext events
*/
update
 events ext,
 events vdr
set
 ext.useid = case when ext.updflg in('I','R') then vdr.masterid else ext.useid end,
 ext.updflg = case when ext.updflg in('I','R') then 'C' else 'T' end,
 ext.updsp = case when ext.updflg in('I','R') then unix_timestamp() else ext.updsp end
where
 ext.masterid = vdr.useid and
 ext.channelid = vdr.channelid and
 ext.updflg in('I','A','R','S') and
 ext.source <> vdr.source and
 vdr.source = 'vdr';
/*
* update all other relevant updflg and updsp
*/
update
 events ev,
 (select distinct channelid,mergesp from channelmap where source != 'vdr') cm
set
 ev.updflg = case when ev.source = 'vdr' and ev.masterid != ev.useid then 'L'
                  when ev.source = 'vdr' and ev.masterid = ev.useid then 'A'
                  when ev.source != 'vdr' and ev.updflg = 'S' then 'I'
                  when ev.source != 'vdr' then 'R'
             end,
 ev.updsp = case when source = 'vdr' and ev.masterid = ev.useid and ev.updflg = 'A' then ev.updsp
                 else unix_timestamp()
            end
where
 ev.channelid = cm.channelid and
 ev.starttime < cm.mergesp + ev.duration/5 and
 ( ev.source = 'vdr' and ev.updflg in ('I','A') or
  ev.source != 'vdr' and ev.updflg in ('A','S') );
/*
* reinitialize prior removed dvb events
*/
update
 events ev,
 (select distinct channelid,mergesp from channelmap where source != 'vdr') cm
set
 ev.updflg = 'A',
 ev.useid = ev.masterid,
 ev.updsp = unix_timestamp()
where
 ev.channelid = cm.channelid and
 ev.starttime < cm.mergesp + ev.duration/5 and
 ev.source = 'vdr' and
 ev.updflg in ('R');
/*
* get startrun / lastrun
*/
SET startrun = (select unix_timestamp());
SET lastrun = (select value from parameters where owner = 'epgd' and name = 'mergeStart');
/*
* truncate useevents if needed
*/
IF lastrun = 0 then truncate table useevents;
END IF;
/*
* update useevents
*/
insert into
 useevents( cnt_source, cnt_channelid, cnt_eventid, cnt_masterid, cnt_useid, sub_source, sub_eventid, all_updsp, cnt_updflg, cnt_delflg, cnt_fileref, cnt_tableid, cnt_version, sub_title, sub_shorttext, sub_comptitle, sub_compshorttext, sub_genre, sub_country, sub_year, cnt_starttime, cnt_duration, cnt_parentalrating, cnt_vps, cnt_contents, sub_category, sub_shortdescription, sub_shortreview, sub_tipp, sub_rating, sub_numrating, sub_topic, sub_longdescription, sub_complongdescription, cnt_longdescription, sub_info, sub_moderator, sub_guest, sub_actor, sub_producer, sub_other, sub_director, sub_screenplay, sub_camera, sub_music, sub_audio, sub_flags, sub_imagecount, sub_scrseriesid, sub_scrseriesepisode, sub_scrmovieid, sub_scrsp, sub_episodecompname, sub_episodecompshortname, sub_episodecomppartname, epi_episodename, epi_shortname, epi_partname, epi_lang, epi_extracol1, epi_extracol2, epi_extracol3, epi_season, epi_part, epi_parts, epi_number )
select
 cnt.source cnt_source,
 cnt.channelid cnt_channelid,
 cnt.eventid cnt_eventid,
 cnt.masterid cnt_masterid,
 cnt.useid cnt_useid,
 sub.source sub_source,
 sub.eventid sub_eventid,
 GREATEST(cnt.updsp,sub.updsp,IFNULL(epi.updsp,0)) all_updsp,
 cnt.updflg cnt_updflg,
 cnt.delflg cnt_delflg,
 cnt.fileref cnt_fileref,
 cnt.tableid cnt_tableid,
 cnt.version cnt_version,
 sub.title sub_title,
 sub.shorttext sub_shorttext,
 sub.comptitle sub_comptitle,
 sub.compshorttext sub_compshorttext,
 sub.genre sub_genre,
 sub.country sub_country,
 sub.year sub_year,
 cnt.starttime cnt_starttime,
 cnt.duration cnt_duration,
 cnt.parentalrating cnt_parentalrating,
 cnt.vps cnt_vps,
 cnt.contents cnt_contents,
 sub.category sub_category,
 sub.shortdescription sub_shortdescription, 
 sub.shortreview sub_shortreview,
 sub.tipp sub_tipp,
 sub.rating sub_rating,
 sub.numrating sub_numrating,
 sub.topic sub_topic,
 sub.longdescription sub_longdescription,
 sub.complongdescription sub_complongdescription,
 cnt.longdescription cnt_longdescription,
 sub.info sub_info,
 sub.moderator sub_moderator,
 sub.guest sub_guest,
 sub.actor sub_actor,
 sub.producer sub_producer,
 sub.other sub_other,
 sub.director sub_director,
 sub.screenplay sub_screenplay,
 sub.camera sub_camera,
 sub.music sub_music,
 sub.audio sub_audio,
 sub.flags sub_flags,
 sub.imagecount sub_imagecount,
 sub.scrseriesid sub_scrseriesid,
 sub.scrseriesepisode sub_scrseriesepisode,
 sub.scrmovieid sub_scrmovieid,
 sub.scrsp sub_scrsp,
 sub.episodecompname sub_episodecompname,
 sub.episodecompshortname sub_episodecompshortname,
 sub.episodecomppartname sub_episodecomppartname,
 epi.episodename epi_episodename,
 epi.shortname epi_shortname,
 epi.partname epi_partname,
 epi.lang epi_lang,
 epi.extracol1 epi_extracol1,
 epi.extracol2 epi_extracol2,
 epi.extracol3 epi_extracol3,
 epi.season epi_season,
 epi.part epi_part,
 epi.parts epi_parts,
 epi.number epi_number
from
 events cnt
 inner join events sub on (case when cnt.useid = 0 then cnt.masterid else cnt.useid end = sub.masterid)
 left outer join episodes epi on (sub.episodecompname = epi.compname and sub.episodecomppartname = epi.comppartname and sub.episodelang = epi.lang)
where
 cnt.updflg in('A','L','P','C','R','D','X') and
 GREATEST(cnt.updsp,sub.updsp) >= lastrun - 5
ON DUPLICATE KEY
update
 cnt_source = values(cnt_source),
 cnt_channelid = values(cnt_channelid),
 cnt_eventid = values(cnt_eventid),
 cnt_masterid = values(cnt_masterid),
 cnt_useid = values(cnt_useid),
 sub_source = values(sub_source),
 sub_eventid = values(sub_eventid),
 all_updsp = values(all_updsp),
 cnt_updflg = values(cnt_updflg),
 cnt_delflg = values(cnt_delflg),
 cnt_fileref = values(cnt_fileref),
 cnt_tableid = values(cnt_tableid),
 cnt_version = values(cnt_version),
 sub_title = values(sub_title),
 sub_shorttext = values(sub_shorttext),
 sub_comptitle = values(sub_comptitle),
 sub_compshorttext = values(sub_compshorttext),
 sub_genre = values(sub_genre),
 sub_country = values(sub_country),
 sub_year = values(sub_year),
 cnt_starttime = values(cnt_starttime),
 cnt_duration = values(cnt_duration),
 cnt_parentalrating = values(cnt_parentalrating),
 cnt_vps = values(cnt_vps),
 cnt_contents = values(cnt_contents),
 sub_category = values(sub_category),
 sub_shortdescription = values(sub_shortdescription),
 sub_shortreview = values(sub_shortreview),
 sub_tipp = values(sub_tipp),
 sub_rating = values(sub_rating),
 sub_numrating = values(sub_numrating),
 sub_topic = values(sub_topic),
 sub_longdescription = values(sub_longdescription),
 sub_complongdescription = values(sub_complongdescription),
 cnt_longdescription = values(cnt_longdescription),
 sub_info = values(sub_info),
 sub_moderator = values(sub_moderator),
 sub_guest = values(sub_guest),
 sub_actor = values(sub_actor),
 sub_producer = values(sub_producer),
 sub_other = values(sub_other),
 sub_director = values(sub_director),
 sub_screenplay = values(sub_screenplay),
 sub_camera = values(sub_camera),
 sub_music = values(sub_music),
 sub_audio = values(sub_audio),
 sub_flags = values(sub_flags),
 sub_imagecount = values(sub_imagecount),
 sub_scrseriesid = values(sub_scrseriesid),
 sub_scrseriesepisode = values(sub_scrseriesepisode),
 sub_scrmovieid = values(sub_scrmovieid),
 sub_scrsp = values(sub_scrsp),
 sub_episodecompname = values(sub_episodecompname),
 sub_episodecompshortname = values(sub_episodecompshortname),
 sub_episodecomppartname = values(sub_episodecomppartname),
 epi_episodename = values(epi_episodename),
 epi_shortname = values(epi_shortname),
 epi_partname = values(epi_partname),
 epi_lang = values(epi_lang),
 epi_extracol1 = values(epi_extracol1),
 epi_extracol2 = values(epi_extracol2),
 epi_extracol3 = values(epi_extracol3),
 epi_season = values(epi_season),
 epi_part = values(epi_part),
 epi_parts = values(epi_parts),
 epi_number = values(epi_number);
/*
* remove hidden events
*/
delete from useevents where (cnt_source,cnt_channelid,cnt_eventid) in( select source,channelid,eventid from events where updflg in ('T','S','I') );
/*
* update lastrun
*/
update parameters set updsp = unix_timestamp(), value = startrun where owner = 'epgd' and name = 'mergeStart';
END
