#  ------------------------------------------------------------------------------------------# ----------------------------------------------------
# - after importing 'event' the event object is available
#   with the following methods:
#
#      title
#      shorttext
#      starttime
#      year
#      category
#      episodname
#      shortname
#      partname
#      season
#      part
#      number
#      extracol1
#      extracol2
#      extracol3
#
#      namingmode   // timers naming mode { 1,2,3,4,5 } - see epgservice.h
#
# - implement at least the function 'name()' witch have to return the name of the recording
#   if the result was empty VDRs typical recording name will be used
#  ------------------------------------------------------------------------------------------

import event

def name():

    import locale
    locale.setlocale(locale.LC_ALL, 'de_DE.UTF-8')
    import time

    if event.namingmode() == 1:

        if event.episodname():
            if event.shortname():
                title = event.shortname()
            else:
                title = event.episodname()

            part = "%02i" % int(event.part())
            number = "%03i" % int(event.number())

            if event.title() == 'Tatort':
                if event.extracol1:
                    ermittler = event.extracol1()[11:]
                else:
                    ermittler = ''

                if event.extracol2():
                    ort = event.extracol2()[5:]
                else:
                    ort = ''

                season = str(int(event.season())+1969)
                return "Tatort~" + ort + "~" + ermittler + "~" + season + "x" + part + " - " + number + ". " + event.shorttext()

            else:
                season = "%02i" % int(event.season())
                return title + "~" + season + "x" + part + " - " + number + ". " + event.shorttext()

        elif event.category() == 'Serie':
            if event.shorttext() and event.title() != event.shorttext():
                return event.title() + "~" + event.shorttext()
            else:
                return event.title() + "~" + time.strftime("%a %d.%m.%Y %H:%M", time.localtime(event.starttime()))
        else:
            return event.title()


    elif event.namingmode() == 2:

        if event.episodname():
            if event.shortname():
                title = event.shortname()
            else:
                title = event.episodname()

            part = "%02i" % int(event.part())
            number = "%03i" % int(event.number())

            if event.title() == 'Tatort':
                if event.extracol1:
                    ermittler = event.extracol1()[11:]
                else:
                    ermittler = ''

                if event.extracol2():
                    ort = event.extracol2()[5:]
                else:
                    ort = ''

                season = str(int(event.season())+1969)
                return "Tatort~" + ort + "~" + ermittler + "~" + season + "x" + part + " - " + number + ". " + event.shorttext()

            else:
                if event.title() == 'Polizeiruf 110':
                    season = str(int(event.season())+1971)
                else:
                    season = "%02i" % int(event.season())

                return title + "~" + season + "x" + part + " - " + number + ". " + event.shorttext()

        elif event.shorttext() and event.title() != event.shorttext():
            return event.title() + "~?x? - ?. " + event.shorttext()
        else:
            return event.title() + "~" + time.strftime("%a %d.%m.%Y %H:%M", time.localtime(event.starttime()))

    elif event.namingmode() == 3:
        if event.shorttext() and event.title() != event.shorttext():
            return event.title() + "~" + event.shorttext()
        else:
            return event.title()

    elif event.namingmode() == 4:
        if event.category():
            return event.category() + "~" + event.title()
        else:
            return event.title()

    else:
        return event.title()
